Subject: Re: Kernel header changes break glibc build

From: Al Viro <[email-masked]>
Date: Wed, 6 Dec 2006 20:34:12 +0000

On Wed, Dec 06, 2006 at 09:26:39PM +0100, Thomas Graf wrote:
> * Al Viro <[email-masked]> 2006-12-06 17:13
> > On Wed, Dec 06, 2006 at 03:31:46PM +0100, Thomas Graf wrote:
> >  
> > > At the time they were added they were meant to be exported but netlink
> > > has evolved and we now have a type safe API.
> > 
> > Where?  AFAICS, netlink might be considered type-safe only within an
> > address family...
> 
> The new interface can be found in net/netlink.h, it obsoletes the
> old interface which is spread over linux/netlink.h and linux/rtnetlink.h

... and for different address families you have conflicting policies.
You can't tell if ATTR_... means __le16, __be32, 16byte-array or something
else - the answer depends on the code interpreting the damn thing.
Moreover, you get zero warnings if you use wrong accessor to decode.